<template>
    <div class="is-card team-card">
        <b class="team-type">{{ type }}</b>
        <br />
        <input v-model.lazy="team.name" class="team-name" />
        <br /><br />
        <div class="color-picker">
            <i class="description">Color:</i>
            <input
                v-model="newPColor"
                type="color"
                class="color-input"
                @blur="updatePColor"
            />
        </div>
        <br />
        <div
            class="color-display"
            :style="{ backgroundColor: team.pColor, color: 'white' }"
        >
            <h1 :style="{ color: 'white' }">Preview</h1>
        </div>
        <br />
        <div class="timeout-possession">
            <i class="description">Timeouts</i><br />
            <select v-model="team.timeouts">
                <option value="0">1</option>
                <option value="1">1</option>
                <option value="2">2</option>
                <option value="3">3</option>
            </select>
        </div>
        <div class="timeout-possession">
            <i class="description">Possession</i><br />
            <button
                :class="[possession && 'active', 'clicky']"
                @click="setPossession"
            >
                ➤
            </button>
        </div>
        <br /><br />
        <td class="team-score">{{ team.score }}</td>
        <br />
        <div style="display: flex; justify-content: space-between">
            <input
                v-model="pointsToAdd"
                class="inp-score"
                placeholder="add points"
                type="number"
                @keyup.enter="addPoints"
            />
            <button class="clicky add-score" @click="addPoints">+</button>
        </div>
        <br />
        <button class="clicky touchdown-btn" @click="onTouchdown">
            Touchdown
        </button>
    </div>
</template>

<script lang="ts">
import state from "~/state";
import Vue, { PropType } from "vue";
import wait from "~/helpers/wait";

export default Vue.extend({
    props: {
        type: {
            type: String as PropType<TeamT>,
            required: true,
        },
    },
    data() {
        return {
            pointsToAdd: "",
            newPColor: state.teams[this.type].pColor,
        };
    },
    computed: {
        team(): ITeam {
            return state.teams[this.type];
        },
        possession(): boolean {
            return state.possession === this.type;
        },
    },
    methods: {
        setPossession() {
            state.possession = this.type;
        },
        addPoints(): void {
            const amount = Number(this.pointsToAdd.trim());
            this.team.score += amount;
            this.pointsToAdd = "";
        },
        async onTouchdown() {
            state.triggerTouchdown(this.type);
            await wait(500);
            this.team.score += 6;
        },
        updatePColor() {
            if (/^#([0-9A-F]{3}){1,2}$/i.test(this.newPColor)) {
                this.team.pColor = this.newPColor;
            } else {
                this.newPColor = this.team.pColor;
            }
        },
    },
});
</script>

<style scoped>
.description {
    margin-bottom: 5px;
}
.team-type {
    line-height: 1.5;
    font-size: 25px;
}

.team-card * {
    display: inline-block;
}

.team-card {
    text-align: center;
    width: 250px;
    line-height: 1;
    margin: 0 50px;
}
.team-score {
    display: block;
    font-size: 40px;
    width: 100%;
}

.inp-score {
    width: 75%;
}
.add-score {
    width: 20%;
}
.timeout-possession {
    width: 48%;
}
.timeout-possession > * {
    text-align: center;
    width: 100%;
}
.team-name {
    border: 0px;
    padding: 0px;
    margin: 0px;
    width: 100%;
    font-size: 20px;
    font-style: italic;
}
.touchdown-btn {
    width: 100%;
}
.color-picker {
    width: 100%;
    display: flex;
    align-items: center;
}
.color-picker .description {
    margin-right: 15px;
}
.color-display {
    height: 35px;
    width: 100%;
    border: 2px solid;
    display: flex;
    justify-content: center;
    align-items: center;
    font-size: 25px;
}
.color-input {
    border: 0px;
    padding: 0px;
    margin: 0px;
    width: 100%;
    font-size: 20px;
    font-style: italic;
}
</style>
